#!/bin/sh
#
# To activate this git hook on your local dev environment:
# copy or symlink this file to .git/hooks/pre-commit, and chmod +x to make executable

if git rev-parse --verify HEAD >/dev/null 2>&1
then
	against=HEAD
else
	# Initial commit: diff against an empty tree object
	against=$(git hash-object -t tree /dev/null)
fi

# If you want to allow non-ASCII filenames set this variable to true.
allownonascii=$(git config --bool hooks.allownonascii)

# Redirect output to stderr.
exec 1>&2

# Cross platform projects tend to avoid non-ASCII filenames; prevent
# them from being added to the repository. We exploit the fact that the
# printable range starts at the space character and ends with tilde.
if [ "$allownonascii" != "true" ] &&
	# Note that the use of brackets around a tr range is ok here, (it's
	# even required, for portability to Solaris 10's /usr/bin/tr), since
	# the square bracket bytes happen to fall in the designated range.
	test $(git diff --cached --name-only --diff-filter=A -z $against |
	  LC_ALL=C tr -d '[ -~]\0' | wc -c) != 0
then
	cat <<\EOF
Error: Attempt to add a non-ASCII file name.

This can cause problems if you want to work with people on other platforms.

To be portable it is advisable to rename the file.

If you know what you are doing you can disable this check using:

  git config hooks.allownonascii true
EOF
	exit 1
fi

if [ -n "$VIRTUAL_ENV" ]; then
    echo "Trying to activate venv at $VIRTUAL_ENV"
    . "$VIRTUAL_ENV"/bin/activate
else
    echo "Trying to activate venv at ./.venv"
    . ./.venv/bin/activate
fi

OUT1=`make dev-test 1>&2`
if [ $? -eq 0 ]; then
    echo "Tests passed\n"
else
    echo "Tests failed! Cannot commit changes.\n"
	exit 1
fi
OUT2=`make lint 1>&2`
if [ $? -eq 0 ]; then
    echo "Lints passed\n"
else
    echo "Lints failed! Cannot commit changes.\n"
	exit 1
fi
OUT3=`make type-check 1>&2`
if [ $? -eq 0 ]; then
    echo "Type Checking passed\n"
else
    echo "Type Checking failed! Cannot commit changes.\n"
	exit 1
fi


# If there are whitespace errors, print the offending file names and fail.
exec git diff-index --check --cached $against --
